<template>
  <q-page>
    <q-page-sticky position="top-right">
      <div class="column">
        <q-btn glossy color="accent" :label="$t('results.exportCategory')"
               class="q-ma-lg" @click="exportCategory()" />
        <q-btn glossy color="accent" :label="$t('results.exportFormatted')"
               class="q-ma-lg" @click="exportFormattedResults()" />
        <q-btn glossy color="accent" :label="$t('results.exportPlain')"
               class="q-ma-lg" @click="exportPlain()" />
      </div>
    </q-page-sticky>

    <div class="row">
      <div class="q-drawer-container" style="width: 270px">
        <aside class="q-drawer q-drawer-left scroll bg-grey-3 q-drawer-normal"
               style="transform: translateX(0px); position: relative;">
          <q-list no-border link inset-delimiter padding>
            <q-input v-model="ctgFilter" :label="$t('default.categoryFilter')"
                     class="q-ml-md q-mr-md" />
            <q-item v-for="ctg in filteredCategoryData"
                    class="cursor-pointer"
                    clickable
                    :key="ctg._id" v-on:click="changeCategory(ctg._id)">
              <q-item-section avatar>
                <q-icon color="primary" name="fas fa-graduation-cap" />
              </q-item-section>
              <q-item-section>
                <q-item-label>{{ ctg.name }}</q-item-label>
                <q-item-label caption>{{ ctg.ageTo }}</q-item-label>
              </q-item-section>
              <q-item-section avatar right v-if="ctg._id === selectedCategory">
                <q-icon name="fas fa-arrow-circle-right"/>
              </q-item-section>
            </q-item>
          </q-list>
        </aside>
      </div>

      <q-table
        :title = "$t('results.outcomes')"
        :rows = "tableData"
        :columns = "columns"
        :loading = "loading"
        :pagination = "pagination"
        row-key = "startingNumber"
        dense
        color = "primary"
      >
      </q-table>
    </div>
  </q-page>
</template>

<script setup lang="js">
import log from 'src/service/messaging-service';
import ux from 'src/service/ux-service';
import _ from 'lodash';
import {computed, onMounted, reactive, ref, toRaw} from 'vue';
import {useQuasar} from 'quasar';

const ipcMain = window.ipcMain;
const $q = useQuasar();
const $t = log.getI18n();

const loading = ref(false);
const selectedCategory = ref('');
const ctgFilter = ref('');
const categoryData = reactive([]);
const columns =  reactive([]);
const columnsData =  reactive([]);
const tableData =  reactive([]);
const pagination =  reactive({ rowsPerPage: 0 });

const filteredCategoryData = computed(() =>
  categoryData.filter((ctg) =>
    // eslint-disable-next-line implicit-arrow-linebreak
    ctg.name.toLowerCase().includes(ctgFilter.value.toLowerCase())
  )
)

async function ctgLoadFromDb() {
  const response = await ipcMain.send('category-get-all-data');
  if (response.status === 'fail') log.error(response.message);
  else {
    categoryData.splice(0, categoryData.length, ...response.message);
    selectedCategory.value = categoryData[0]._id;
    await discLoadFromDb();
  }
}

async function discLoadFromDb() {
  const response = await ipcMain.send('disciple-filter-data', toRaw(selectedCategory.value));
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    fillColumns(response.message);
    await dataLoadFromDb();
  }
}

async function dataLoadFromDb() {
  loading.value = true;
  const response = await ipcMain.send('person-filter-data', { categoryId: selectedCategory.value });
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    tableData.splice(0);
    response.message.forEach((row) => {
      const rowEntity = _.pick(row, ['_id', 'startingNumber', 'club', 'year', 'totalScore', 'finalOrder']);
      rowEntity.fullName = `${row.firstName} ${row.lastName}`;
      columnsData.forEach((col) => {
        if (col.datatype === 'time') {
          rowEntity[col._id] = ux.formatTime(row[col._id]);
        } else {
          rowEntity[col._id] = row[col._id];
        }
        rowEntity[`${col._id}_score`] = row[`${col._id}_score`];
      });
      tableData.push(rowEntity);
    });
    loading.value = false;
  }
}

function fillColumns(rows) {
  columnsData.splice(0, columnsData.length, ...rows);
  columns.splice(0, columns.length,
    {
      name: 'startingNumber',
      field: 'startingNumber',
      label: 'Start. #',
    }, {
      name: 'fullName',
      field: 'fullName',
      label: 'Jméno',
    }, {
      name: 'club',
      field: 'club',
      label: 'Klub / Město',
    }, {
      name: 'year',
      field: 'year',
      label: 'Rok nar.',
    }
  );
  rows.forEach((row) => {
    columns.push({
      name: row._id,
      field: row._id,
      label: row.label,
    });
    columns.push({
      name: `${row._id}_score`,
      field: `${row._id}_score`,
      label: `${row.label} Skóre`,
    });
  });
  columns.push({
    name: 'totalScore',
    field: 'totalScore',
    label: 'Bodů',
  });
  columns.push({
    name: 'finalOrder',
    field: 'finalOrder',
    label: 'Pořadí',
  });
}

function changeCategory(ctgId) {
  selectedCategory.value = ctgId;
  discLoadFromDb();
}

async function exportCategory() {
  // TODO add waiting sandglass
  const response = await ipcMain.send('export-category', selectedCategory.value);
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    log.info(
      $t('results.exportCategorySuccess',
        { category: categoryData.find((ctg) => ctg._id === selectedCategory.value).name, exportPath: response.exportPath }),
    );
    await dataLoadFromDb();
  }

}

function exportFormattedResults() {
  // TODO add waiting sandglass
  const configObj = {
    title: $t('results.exportFormatted'),
    message: $t('results.export.message'),
    options: {
      type: 'radio',
      model: 'opt1',
      items: [
        { label: $t('results.export.all'), value: 'all' },
        { label: $t('results.export.best'), value: 'best' },
      ],
    },
    cancel: true,
    preventClose: true,
    color: 'secondary',
  };

  $q.dialog(configObj)
    .onOk(async (dialogResult) => {
      const response = await ipcMain.send('export-formatted', dialogResult);
      if (response.status === 'fail') {
        log.error(response.message);
      } else {
        log.info(this.$t('results.exportFormattedSuccess', { exportPath: response.exportPath }));
        await dataLoadFromDb();
      }

    });
}

async function exportPlain() {
  // TODO add waiting sandglass
  const response = await ipcMain.send('export-plain');
  if (response.status === 'fail') {
    log.error(response.message);
  } else {
    log.info($t('results.exportPlainSuccess', { exportPath: response.exportPath }));
    await dataLoadFromDb();
  }
}

onMounted(() => {
  // once mounted, we need to trigger the initial server data fetch
  ctgLoadFromDb();
});
</script>

<style>
</style>
